/************************************************************************************
 *
 *   file name   : func_key1.c
 *   Contents    : Key on wake-up (use to exit wait mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit INTEDGE_bit7 = INTEDGE.7;
bit IREQ1_bit4 = IREQ1.4;
bit ICON1_bit4 = ICON1.4;

/*==================================================================================*/

zpage char KEY_ON_FLAG;
zpage char KEY_CODE;

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{

		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();				/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		PULL		= 0x07;					/* set P0_0 to P0_3 pins pull-up */

		enable_interrupt();					/* Interrupt enable */

		while(1){
			INTEDGE_bit7 = 0;				/* enable key on wake-up interrupt */
			IREQ1_bit4 = 0;					/* clear key on wake-up interrupt request */
			ICON1_bit4 = 1;					/* enable key on wake-up interrupt */
			
			enter_wait_mode();

			if(KEY_ON_FLAG == 1){
				/* write processing */
			}
		}
}

/************************************************************************************
 *
 *      interrupt Key on wake-up
 *
*************************************************************************************/
void interrupt[22] int_KEY(void)
{
		cld_instruction();

		
		if((P0 & 0x0F) != 0x0F){
			KEY_ON_FLAG = 1;
			KEY_CODE = P0 & 0x0F;
		}
		else{
			KEY_ON_FLAG = 0;
		}
}

/************************************************************************************/
