/************************************************************************************
 *
 *   file name   : func_sio_re.c
 *   Contents    : synchronous serial I/O communication (receive)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit SIOSTS_bit1 = SIOSTS.1;

/*==================================================================================*/
zpage char Receive_Data1;
zpage char Receive_Data2;

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		SIOCON		= 0xF6;						/* synchronous clock : external clock */
												/* P1_3 pin function : SRDY output pin */
												/* enable transmit */
												/* enable receive */
												/* serial I/O mode : synchronous serial I/O mode */
												/* enable serial I/O */

		TCSS2 = 0x00;							/* select timer 1 count source ; f(Xin)/16 */
		PRE1 = 65-1;
		T1 = 8-1;
		IREQ2_bit5 = 0;							/* clear timer 1 interrupt request */
		nop_instruction();
		
		while(1){
			while(IREQ2_bit5 == 0);				/* 2ms ? */
			IREQ2_bit5 = 0;						/* clear timer 1 interrupt request */
 			
 			TBRB = 0x00;						/* dummy write */
			while(SIOSTS_bit1 == 0);			/* wait data receive */
			Receive_Data1 = TBRB;				/* store receive data */
			
			TBRB = 0x00;						/* dummy write */
			while(SIOSTS_bit1 == 0);			/* wait data receive */
			Receive_Data2 = TBRB;				/* store next receive data */
		}
}

/************************************************************************************/
