/************************************************************************************
 *
 *   file name   : func_sio_tr.c
 *   Contents    : synchronous serial I/O communication (transmit)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit INTEDGE_bit0 = INTEDGE.0;
bit IREQ1_bit2 = IREQ1.2;
bit SIOSTS_bit0 = SIOSTS.0;
bit SIOSTS_bit2 = SIOSTS.2;

/*==================================================================================*/

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		char SEND_DATA1;
		char SEND_DATA2;

		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		SIOCON		= 0xd0;						/* BRG count source : f(Xin) */
												/* synchronous clock : divided 4 */
												/* P1_3 function : normal I/O pin */
												/* interrupt request factor : transmit buffer is empty */
												/* enable transmit */
												/* disable receive */
												/* serial I/O mode : synchronous serial I/O mode */
												/* enable serial I/O */
		BRG			= 0x07;						/* set baud rate */
		
		INTEDGE_bit0 = 0;						/* INT0 falling edge active */

		SEND_DATA1	= 0x55;						/* set send data */
		SEND_DATA2	= 0xAA;
		
		while(1){
			while(IREQ1_bit2 == 0);				/* wait input INT0 falling edge */
			IREQ1_bit2 = 0;						/* clear INT0 interrupt request */
			
			TBRB = SEND_DATA1;					/* write trasmit data */
			while(SIOSTS_bit0 == 0);			/* wait data send */
			TBRB = SEND_DATA2;					/* write next transmit data */
			while(SIOSTS_bit0 == 0);			/* wait data send */
			while(SIOSTS_bit2 == 0);			/* wait transmit sift completed */
			
		}
}

/************************************************************************************/
