/************************************************************************************
 *
 *   file name   : func_uart_re.c
 *   Contents    : asynchronous serial I/O communication (receive)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit SIOSTS_bit1 = SIOSTS.1;
bit SIOSTS_bit6 = SIOSTS.6;

/*==================================================================================*/

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		char Receive_Data1;
		char Receive_Data2;

		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		SIOCON		= 0xa1;						/* BRG count source : f(Xin)/4 */
												/* synchronous clock : divided 16 */
												/* disable transmit */
												/* enable receive */
												/* serial I/O mode : asynchronous serial I/O mode */
												/* enable serial I/O */
		UARTCON		= 0x08;						/* character length bit : 8 bits */
												/* disable parity */
												/* 2 stop bits */
		BRG			= 0x07;						/* set buad rate */
		
		P0D			= 0x00;						/* set port P0 direction register */
		
		while(1){
			while(SIOSTS_bit1 == 0);			/* wait data receive */
			Receive_Data1 = TBRB;				/* write trasmit data */
			
			if(SIOSTS_bit6 != 1){
				while(SIOSTS_bit1 == 0);		/* wait data receive */
				Receive_Data2 = TBRB;			/* write next transmit data */
				if(SIOSTS_bit6 != 1){
					while(P0_0 == 0);
				}
				else{
					SIOSTS = 0x00;				/* clear all error flag */
					/* write error processing */
				}
			}
			else{
				SIOSTS = 0x00;					/* clear all error flag */
				/* write error processing */
			}
		}
}

/************************************************************************************/
