;/****************************************************************************
;*                                                                           *
;*   file name   : io7544.inc                                                *
;*                                                                           *
;*   Copyright   : RENESAS TECHNOLOGY CORPORATION                            *
;*                                                                           *
;*   Version     : 1.00  ( 2004-6-11 ) Initial                               *
;*                                                                           *
;*****************************************************************************/
;/*
;  note:
;    This data is a freeware that SFR for 7544 Group is described.
;    RENESAS TECHNOLOGY CORPORATION assumes no responsibility for any damage
;    that occurred by this data.
;*/

;/*===================================
; *   Special function registers (SFR)
; *===================================
; */

P0       = $0000      ; Port P0
P0D      = $0001      ; Port P0 direction register
P1       = $0002      ; Port P1
P1D      = $0003      ; Port P1 direction register
P2       = $0004      ; Port P2
P2D      = $0005      ; Port P2 direction register
P3       = $0006      ; Port P3
P3D      = $0007      ; Port P3 direction register

PULL     = $0016      ; Pull-up control register
P1P3C    = $0017      ; Port P1P3 control register
TBRB     = $0018      ; Transmit /Receive buffer register
SIOSTS   = $0019      ; Serial I/O status register
SIOCON   = $001a      ; Serial I/O control register
UARTCON  = $001b      ; UART control register
BRG      = $001c      ; Baud rate generator
TAM      = $001d      ; Timer A mode register
TAL      = $001e      ; Timer A (low-order)
TAH      = $001f      ; Timer A (high-order)

PRE1     = $0028      ; Prescaler 1
T1       = $0029      ; Timer 1

TXM      = $002b      ; Timer X mode register
PREX     = $002c      ; Prescaler X
TX       = $002d      ; Timer X
TCSS1    = $002e      ; Timer count source set register 1
TCSS2    = $002f      ; Timer count source set register 2

ADCON    = $0034      ; A-D control register
AD       = $0035      ; A-D register

MISRG    = $0038      ; MISRG
WDTCON   = $0039      ; Watchdog timer control register
INTEDGE  = $003a      ; Interrupt edge selection register
CPUM     = $003b      ; CPU mode register
IREQ1    = $003c      ; Interrupt request register 1
IREQ2    = $003d      ; Interrupt request register 2
ICON1    = $003e      ; Interrupt control register 1
ICON2    = $003f      ; Interrupt control register 2

;/*------------------------------------------------------
;  Port P0 register
;------------------------------------------------------*/
P0_0     = 0,P0         ; P0 register bit0
P0_1     = 1,P0         ; P0 register bit1
P0_2     = 2,P0         ; P0 register bit2
P0_3     = 3,P0         ; P0 register bit3
P0_4     = 4,P0         ; P0 register bit4
P0_5     = 5,P0         ; P0 register bit5
P0_6     = 6,P0         ; P0 register bit6
P0_7     = 7,P0         ; P0 register bit7

;/*------------------------------------------------------
;  Port P1 register
;------------------------------------------------------*/
P1_0     = 0,P1         ; P1 register bit0
P1_1     = 1,P1         ; P1 register bit1
P1_2     = 2,P1         ; P1 register bit2
P1_3     = 3,P1         ; P1 register bit3
P1_4     = 4,P1         ; P1 register bit4

;/*------------------------------------------------------
;  Port P2 register
;------------------------------------------------------*/
P2_0     = 0,P2         ; P2 register bit0
P2_1     = 1,P2         ; P2 register bit1
P2_2     = 2,P2         ; P2 register bit2
P2_3     = 3,P2         ; P2 register bit3
P2_4     = 4,P2         ; P2 register bit4
P2_5     = 5,P2         ; P2 register bit5

;/*------------------------------------------------------
;  Port P3 register
;------------------------------------------------------*/
P3_0     = 0,P3         ; P3 register bit0
P3_1     = 1,P3         ; P3 register bit1
P3_2     = 2,P3         ; P3 register bit2
P3_3     = 3,P3         ; P3 register bit3
P3_4     = 4,P3         ; P3 register bit4
P3_5     = 5,P3         ; P3 register bit5
P3_6     = 6,P3         ; P3 register bit6
P3_7     = 7,P3         ; P3 register bit7


