/************************************************************************************
 *
 *   file name   : func_timer1.c
 *   Contents    : TimerA(25ms)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON2_bit2 = ICON2.2;
bit IREQ2_bit2 = IREQ2.2;
bit TAM_bit7 = TAM.7;

/*==================================================================================*/

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
        /***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM	   = 0x80;
		ICON2_bit5 = 0;
		IREQ2_bit5 = 0;
		TCSS2      = 0x02;
		PRE1       = 200-1;
		T1         = 100-1;
		IREQ2_bit5 = 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		ICON2_bit2 = 0;                         /* TimerA interrupt disable */
		TAM        = 0x80;                      /* Set Timer A mode register */
		TCSS2	   = 0x00;						/* Select Timer A count source mode : f(XIN)/16 */
		TAL        = 0xD3;                      /* Set Timer A (low-order) */
		TAH        = 0x30;                      /* Set Timer A (high-order) */
		IREQ2_bit2 = 0;                         /* TimerA interrupt request clear */
		ICON2_bit2 = 1;                         /* TimerA interrupt disable */
		
		TAM_bit7   = 0;                         /* Timer A start */

		enable_interrupt();                     /* Interrupt enable */
		
		while(1){}
}

/************************************************************************************
 *
 *      interrupt
 *
*************************************************************************************/
void interrupt[10] int_TA(void)
{
		cld_instruction();

}

/************************************************************************************/
