/************************************************************************************
 *
 *   file name   : func_timer2.c
 *   Contents    : Timer A (cycle measurement mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON1_bit6 = ICON1.6;
bit ICON2_bit2 = ICON2.2;
bit P0D_0 = P0D.0;
bit INTEDGE_bit7 = INTEDGE.7;
bit IREQ1_bit6 = IREQ1.6;
bit IREQ2_bit2 = IREQ2.2;
bit TAM_bit7 = TAM.7;

/*==================================================================================*/
zpage	char B_RESULT1;
zpage	char B_RESULT2;
zpage	char C_ERROR;

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
        nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		ICON1_bit6		= 0;					/* disable CNTR1 interrupt */
		ICON2_bit2		= 0;					/* disable timer A interrupt */
		
		P0D_0			= 0;
		PULL			= 0x00;					/* set P0_0 input mode */
		
		TAM				= 0xD0;					/* cycle measurement mode */
												/* measurement rising edge */
												/* CNTR1 interrupt request : falling edge */
												/* stop timer A count */
		
		TCSS2			= 0x00;					/* select timer A count source : f(Xin)/16 */
		
		TAL				= 0xFF;					/* set timer A low-order */
		TAH				= 0xFF;					/* set timer A high-order */
		
		INTEDGE_bit7	= 1;					/* disable interrupt key on wake-up */
		
		IREQ1_bit6		= 0;					/* clear CNTR1 interrupt request */
		IREQ2_bit2		= 0;					/* clear timer A interrupt request */

		ICON1_bit6		= 1;					/* enable CNTR1 interrupt */
		ICON2_bit2		= 1;					/* enable timer A interrupt */
		
		TAM_bit7		= 0;					/* start timer A count */

		enable_interrupt();						/* Interrupt enable */

		while(1){}

}

/************************************************************************************
 *
 *      interrupt CNTR1
 *
*************************************************************************************/
void interrupt[18] int_CNTR1(void)
{
		cld_instruction();
		
		B_RESULT2 = TAH;
		B_RESULT1 = TAL;
		
		TAL = 0xFF;
		TAH = 0xFF;

}

/************************************************************************************
 *
 *      interrupt Timer A
 *
*************************************************************************************/
void interrupt[10] int_TA(void)
{
		cld_instruction();
		
		/* Error Process */

}

/************************************************************************************/
