/************************************************************************************
 *
 *   file name   : func_timer3.c
 *   Contents    : Timer A (event counter mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON1_bit6 = ICON1.6;
bit ICON2_bit2 = ICON2.2;
bit ICON1_bit7 = ICON1.7;
bit P0D_0 = P0D.0;
bit PULL_bit0 = PULL.0;
bit IREQ2_bit2 = IREQ2.2;
bit IREQ1_bit7 = IREQ1.7;
bit	TAM_bit7   = TAM.7;
bit TXM_bit3   = TXM.3;

/*==================================================================================*/
zpage	char RESULT1;
zpage	char RESULT2;

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		ICON1_bit6		= 0;					/* disable CNTR1 interrupt */
		ICON2_bit2		= 0;					/* disable timer A interrupt */
		ICON1_bit7		= 0;					/* disable timer X interrupt */
		
		P0D				= 0x00;
		PULL_bit0		= 0;					/* set P0_0 input mode */
		
		TAM				= 0xE0;					/* event count mode */
												/* falling edge counting */
												/* stop timer A count */
		
		TCSS2			= 0x00;					/* select timer A count source : f(Xin)/16 */
		
		TAL				= 0xFF;					/* set timer A low-order */
		TAH				= 0xFF;					/* set timer A high-order */
		
		TXM				= 0x08;					/* timer mode */
												/* stop timer count */
												
		TCSS1			= 0x00;					/* select timer X count source : f(Xin)/16 */
		
		PREX			= 0x01;					/* set prescaler X */
		TX				= 0xF9;					/* set timer X */
		
		INTEDGE			= 0x80;					/* disable interrupt key on wake-up */
		
		TAM				= 0x60;					/* start timer A count */
		
		IREQ1_bit7		= 0;					/* clear timer X interrupt request */
		ICON1_bit7		= 1;					/* enable timer X interrupt */
		
		TXM				= 0x00;					/* start timer X count */

		enable_interrupt();						/* Interrupt enable */

		while(1){}

}

/************************************************************************************
 *
 *      interrupt Timer X
 *
*************************************************************************************/
void interrupt[16] int_TX(void)
{
		cld_instruction();
		
		TAM_bit7 = 1;						/* stop timer A count */
		TXM_bit3 = 1;						/* stop timer X count */
		
		RESULT1 = 0xff - TAL;
		RESULT2 = 0xff - TAH;
		TAL = 0xFF;
		TAH = 0xFF;

		PREX = 0x01;						/* set prescaler X */
		TX = 0xF9;							/* set timer X */
		
		TAM_bit7 = 0;						/* start timer A count */
		TXM_bit3 = 0;						/* start timer X count */

}

/************************************************************************************/
