/************************************************************************************
 *
 *   file name   : func_timer5.c
 *   Contents    : Timer X (timer mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON1_bit7 = ICON1.7;
bit IREQ1_bit7 = IREQ1.7;
bit TXM_bit3   = TXM.3;

/*==================================================================================*/
zpage	char BASE_250ms;
zpage	char second;
zpage	char minute;
zpage	char hour;
zpage	char f_REQ_SET;
zpage	char f_STOP_CLOCK;

void Set_clock(void);

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		ICON1_bit7		= 0;					/* disable timer X interrupt */
		
		TXM				= 0x08;					/* timer mode */
												/* stop timer X count */

		TCSS1			= 0x00;					/* select timer X count source : f(XIN)/16 */
		
		PREX			= 0xFF;					/* set prescaler X */
		TX				= 0xFF;					/* set timer X */
		
		IREQ1_bit7		= 0;					/* clear timer X interrupt request */
		ICON1_bit7		= 1;					/* enable timer X interrupt */
		
		TXM_bit3		= 0;					/* start timer X count */

		f_REQ_SET		= 1;
		f_STOP_CLOCK	= 1;

		enable_interrupt();						/* Interrupt enable */

		while(1){
			if(f_REQ_SET == 1){					/* clock setting ? */
				Set_clock();
			}
		}

}

/************************************************************************************
 *
 *      sub-routine (set clock)
 *
*************************************************************************************/
void Set_clock(void){
		ICON1_bit7 = 0;					/* disable timer X interrupt */
		
		hour = 0;						/* set clock [0:00] */
		minute = 0;
		second = 0;
		BASE_250ms = 0;
		
		f_REQ_SET = 0;
		f_STOP_CLOCK = 0;
		
		TXM_bit3 = 1;					/* stop timer X count */
		PREX = 0xFF;					/* set prescaler X */
		TX = 0xFF;						/* set timer X */
		
		IREQ1_bit7 = 0;					/* clear timer X interrupt request */
		ICON1_bit7 = 1;					/* enable timer X interrupt */
		
		TXM_bit3 = 0;					/* start timer X count */

}

/************************************************************************************
 *
 *      interrupt Timer X
 *
*************************************************************************************/
void interrupt[16] int_TX(void)
{
		cld_instruction();

		if(f_STOP_CLOCK != 1){
			BASE_250ms ++;
			if(BASE_250ms >= 4){				/* base timer countup */
				BASE_250ms = 0;
				second ++;
			}
			if(second >= 60){					/* set secocnd timer countup */
				second = 0;
				minute ++;
			}
			if(minute >= 60){					/* set minute timer coutup */
				minute = 0;
				hour ++;
			}
			if(hour >= 24){						/* set hour timer countup */
				hour = 0;
			}
		}

}
/************************************************************************************/
