/************************************************************************************
 *
 *   file name   : func_timer7.c
 *   Contents    : Timer X (event counter mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit	ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON1_bit5 = ICON1.5;
bit ICON1_bit7 = ICON1.7;
bit ICON2_bit2 = ICON2.2;
bit IREQ2_bit2 = IREQ2.2;
bit TXM_bit3   = TXM.3;
bit TAM_bit7   = TAM.7;
bit IREQ1_bit7 = IREQ1.7;

/*==================================================================================*/
zpage	char RESULT1;
zpage	char RESULT2;

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		ICON1_bit5		= 0;					/* disable CNTR0 interrupt */
		ICON1_bit7		= 0;					/* disable timer X interrupt */
		ICON2_bit2		= 0;					/* disable timer A interrupt */
		
		P1D				= 0x00;					/* set P1_4 pin input mode */
		
		TXM				= 0x0e;					/* event counter mode */
												/* CNTR0 interrupt priority : falling edge */
												/* stop timer X count */

		TAM				= 0x80;					/* timer mode */
												/* stop timer A count */

		TCSS2			= 0x00;					/* select timer A count source : f(XIN)/16 */
		
		PREX			= 0xff;					/* set prescaler X */
		TX				= 0xff;					/* set timer X */
		
		TAL				= 0x4F;					/* set tiemr A low-order */
		TAH				= 0xC3;					/* set tiemr A high-order */
		
		IREQ2_bit2		= 0;					/* clear timer A interrupt request */
		ICON2_bit2		= 1;					/* enable timer A interrupt */
		IREQ1_bit7		= 0;					/* clear timer X interrupt request */

		TXM_bit3		= 0;					/* start timer X count */
		TAM_bit7		= 0;					/* start timer A count */

		enable_interrupt();						/* Interrupt enable */

		while(1){}

}

/************************************************************************************
 *
 *      interrupt Timer A
 *
*************************************************************************************/
void interrupt[10] int_TA(void)
{
		cld_instruction();

		TXM_bit3 = 1;							/* stop timer X count */
		TAM_bit7 = 1;							/* stop timer A count */

		if(IREQ1_bit7 != 1){
			RESULT1 = 0xff - PREX;				/* event trigger count */
			RESULT2 = 0xff - TX;
		}
		else{
			/* wriet error processing */
		}

		PREX = 0xFF;							/* set Plescaler X */
		TX = 0xFF;								/* set timer X */
		TAL = 0x4F;								/* set tiemr A low-order */
		TAH = 0xC3;								/* set tiemr A high-order */
		
		TXM_bit3 = 0;							/* start timer X count */
		TAM_bit7 = 0;							/* start timer A count */
		
}

/************************************************************************************/
