/************************************************************************************
 *
 *   file name   : func_timer8.c
 *   Contents    : Timer X (pulse width measurement mode)
 *
 *   Copyright, 2004 RENESAS TECHNOLOGY CORPORATION
 *                   AND RENESAS SOLUTIONS CORPORATION
 *
 *   Version     : 1.00  ( 2004-10-30 )
 *
*************************************************************************************/
/************************************************************************************
 *
 *      include
 *
*************************************************************************************/
#include <stdio.h>
#include <intr740.h>
#include "io7544.h"

/************************************************************************************
 *
 *      definition
 *
*************************************************************************************/
bit ICON2_bit5 = ICON2.5;
bit IREQ2_bit5 = IREQ2.5;
bit ICON1_bit5 = ICON1.5;
bit ICON1_bit7 = ICON1.7;
bit P1D_4	   = P1D.4;
bit IREQ1_bit5 = IREQ1.5;
bit IREQ1_bit7 = IREQ1.7;
bit TXM_bit3   = TXM.3;

/*==================================================================================*/
zpage	char RESULT1;
zpage	char RESULT2;
zpage	char ERROR;

/************************************************************************************
 *
 *      main
 *
*************************************************************************************/
void main(void)
{
		/***   wait 10ms(f(Ring))   ***/
		disable_interrupt();					/* Interrupt disable */
		CPUM		= 0x80;
		ICON2_bit5	= 0;
		IREQ2_bit5	= 0;
		TCSS2		= 0x02;
		PRE1		= 200-1;
		T1			= 100-1;
		IREQ2_bit5	= 0;
		nop_instruction();
		
		while(IREQ2_bit5 == 0){}
		
		CPUM = 0x00;
		
		/***   main program   ***/
		ICON1_bit5		= 0;					/* disable CNTR0 interrupt */
		ICON1_bit7		= 0;					/* disable Timer X interrupt */

		P1D				= 0x00;					/* set P1_4 pin input mode */
		
		TXM				= 0x0b;					/* pulse width measurement mode */
												/* CNTR0 interrupt priority : falling edge */
												/* stop timer X count */
		TCSS1			= 0x00;					/* select tiemr X count source : f(XIN)/16 */

		PREX			= 0xff;					/* set prescaler X */
		TX				= 0xff;					/* set timer X */
												/* maximum measurement value 250ms */

		IREQ1_bit5		= 0;					/* clear CNTR0 interrupt request */
		IREQ1_bit7		= 0;					/* clear timer X interrupt request */
		ICON1_bit5		= 1;					/* enable CNTR0 interrupt */
		ICON1_bit7		= 1;					/* enable tiemr X interrupt */
		
		TXM_bit3		= 0;					/* start timer X count */

		enable_interrupt();						/* Interrupt enable */

		while(1){}
}

/************************************************************************************
 *
 *      interrupt Timer X
 *
*************************************************************************************/
void interrupt[16] int_TX(void)
{
		cld_instruction();

		/* error process */

}

/************************************************************************************
 *
 *      interrupt CNTR0
 *
*************************************************************************************/
void interrupt[20] int_CNTR0(void)
{
		cld_instruction();

		TXM_bit3 = 1;

		RESULT1 = PREX;
		RESULT2 = TX;
		
		PREX = 0xFF;
		TX = 0xFF;								/* set timer X initial data */

		TXM_bit3 = 0;

}

/************************************************************************************/
